// PrinterdriverDemoCEDlg.cpp : implementation file
//

#include "stdafx.h"
#include <commctrl.h>
#include "afxwin.h"

#include "PrinterdriverDemoCE.h"
#include "PrinterdriverDemoCEDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrinterdriverDemoCEDlg dialog

CPrinterdriverDemoCEDlg::CPrinterdriverDemoCEDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrinterdriverDemoCEDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPrinterdriverDemoCEDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPrinterdriverDemoCEDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrinterdriverDemoCEDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPrinterdriverDemoCEDlg, CDialog)
	//{{AFX_MSG_MAP(CPrinterdriverDemoCEDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrinterdriverDemoCEDlg message handlers

BOOL CPrinterdriverDemoCEDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


/*===============================*/
/* The Abort Procudure */
/* ==============================*/
BOOL CALLBACK AbortProc( HDC hDC, int Error )
{
	MSG msg;
	while( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return TRUE;
}


void CPrinterdriverDemoCEDlg::OnPrint() 
{
	//static const TCHAR   s_szPrinterName[]  = _T("FlashArmI.dll");	// Flash/MiniMulde
	static const TCHAR   s_szPrinterName[]  = _T("TinyArmI.dll");		// Tiny

    //static const TCHAR   s_szPrinterPort[]  = _T("COM0: 115200");	// seriell
	static const TCHAR   s_szPrinterPort[]  = _T("LPT1:");			// Bluetooth, USB
	//static const TCHAR   s_szPrinterPort[]  = _T("COM7:");		// Ftdi USB

	unsigned int ui32Height = 0;
    DWORD dwError = ERROR_NOT_READY;
	CString output;
	int intOut,i;
	short length;

    CStringList m_oLinesToPrint;
    //* generate a dummy report *//
    m_oLinesToPrint.AddTail( _T("GeBE Printerdriver Test"));
    m_oLinesToPrint.AddTail( _T("Demoapplication") );
	m_oLinesToPrint.AddTail(CString(_T("")));
   
	for(i=0;i<15;i++)
	{
		output.Format(_T("%i. Text"),i+1);
		m_oLinesToPrint.AddTail( output );
	}

	length=(m_oLinesToPrint.GetCount())*40;

    CDC printDC;
    DEVMODE dm;
	
    //dm.dmOrientation    = DMORIENT_PORTRAIT;
	dm.dmOrientation	= DMORIENT_LANDSCAPE;
	dm.dmSize           = sizeof(DEVMODEW);
    dm.dmFields         = DM_PAPERLENGTH | DM_PAPERWIDTH;
    dm.dmPaperLength    = length;
	dm.dmPaperWidth		= 384;

    if( !printDC.CreateDC( s_szPrinterName, s_szPrinterName, s_szPrinterPort, &dm ) )
    {
		output.Format(L"No DC! %i",GetLastError());
        MessageBox (output,TEXT("Error"), MB_OK);
        return;
    }

	/*
	if(GetLastError()==ERROR_NOT_READY)
	{
		output.Format(L"Not ready! %i",GetLastError());
        MessageBox (output,TEXT("Error"), MB_OK);
        return;
    }

	if(GetLastError()==ERROR_OUT_OF_PAPER)
	{
		output.Format(L"Out of paper! %i",GetLastError());
        MessageBox (output,TEXT("Error"), MB_OK);
        return;
    }
	*/

	output.Format(L"Success! %i",GetLastError());
    MessageBox (output,TEXT("Error"), MB_OK);

	// You always have to use an AbortProc().
	if( SetAbortProc( printDC, AbortProc ) == SP_ERROR )
	{
		MessageBox(output, _T("Can not set AbortProc"), MB_OK); 
		return;
	}

	 //initialize print document details
    DOCINFO di;
    memset( &di, 0, sizeof (DOCINFO));
    di.cbSize = sizeof (DOCINFO);

    //begin a new print job
    intOut=printDC.StartDoc( &di );

	
	intOut=printDC.StartPage();

	POSITION posCalc = m_oLinesToPrint.GetHeadPosition();

	for(i=0; i<m_oLinesToPrint.GetCount(); i++ )
	{

		CString csTemp = m_oLinesToPrint.GetNext(posCalc);
		RECT rcTestText;

		int w = printDC.GetDeviceCaps(HORZRES);
		int h = printDC.GetDeviceCaps(VERTRES);
		

		rcTestText.top=i*40;
		rcTestText.left=0;
		rcTestText.bottom=i*40+20;
		rcTestText.right=w;

		//lint !e534 If this fails we will not see the text line on the report
		printDC.DrawText( csTemp, &rcTestText, DT_NOPREFIX | DT_LEFT | DT_TOP );
	

		//lint !e534 If this fails we will not see the text line on the report	
		printDC.DrawText( csTemp, &rcTestText, DT_NOPREFIX | DT_RIGHT | DT_TOP );
		

		rcTestText.top=i*40+25;
		rcTestText.bottom=i*40+35;

		printDC.Rectangle(&rcTestText);

		
	}


	intOut=printDC.EndPage();

	printDC.EndDoc();

	printDC.DeleteDC();
}


